<template>
  <div class="authentication">
    <div class="auth-form">
      <div class="auth-form-password">
        <span>{{ $t('otp.enableAuth.login')}}</span>
        <input
          name="password"
          @keyup.enter="verifyCode"
          type="password"
          @focus="resetError"
          v-model="password"
          data-vv-validate-on="none"
          v-validate="'required'"
        >
        <span class="invalid-feedback" v-if="errors.has('password')">
          {{ errors.first('password') }}
        </span>
      </div>
      <div class="auth-form-code">
        <span>{{ $t('otp.enableAuth.googleAuth')}}</span>
        <input
          name="code"
          v-validate="'required|length:6'"
          @keyup.enter="verifyCode"
          data-vv-as="OTP code"
          type="text"
          @focus="resetError"
          maxlength="6"
          @keypress="isNumber"
          v-model="code"
          data-vv-validate-on="none"
        >
        <span class="invalid-feedback" v-if="errors.has('code')">
          {{ errors.first('code') }}
        </span>
      </div>
    </div>
    <div class="clearfix"></div>
    <div class="auth-form-footer">
      <div class="auth-form-left">
        <button class="btn-step btn-prev-step" @click="$emit('previous')" type="button"><i class="fa fa-angle-left" aria-hidden="true"></i> {{ $t('otp.btnPrev')}}</button>
      </div>
      <div class="auth-form-right">
        <button type="button" class="btn-step btn-enable" @click="verifyCode">{{ $t('otp.modal.title')}}</button>
      </div>
    </div>
  </div>
</template>
<script>
import { mapMutations } from 'vuex';

import OtpInputMixin from './OtpInputMixin';
import rf from '../../requests/RequestFactory';

export default {
  mixins: [OtpInputMixin],
  data () {
    return {
      password: '',
      code: '',
    };
  },
  methods: {
    ...mapMutations([
      'updateUser',
    ]),
    verifyCode() {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          rf.getRequest('UserRequest')
            .addSecuritySettingOtp({'code' : this.code, 'password': this.password})
            .then(res => {
              this.$toasted.show(this.$t('otp.addOtp.message.success'), {
                theme: 'bubble',
                position: 'top-right',
                duration : 2000,
              });
              this.updateUser(res.data);
              this.$broadcast('close-modal');
            })
            .catch(error => {
              this.errors.clear();
              const errors = error.errors;
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        });
    }
  },
};
</script>
<style scoped lang="scss">
  @import '../../../../sass/_variables.scss';

  * {
    font-family: $font-family-home;
  }
  .authentication {
    .auth-form {
      width: 100%;
      input {
        margin-top: 8px;
        width: 330px;
        height: 40px;
        border-radius: 74px;
        background-color: $bg_white;
        border: 1px solid $white;
        text-align: center;
        padding: 0 5px;
        outline: none;
        @media screen and (max-width: 768px){
          width: 300px;
        }
      }
      span {
        font-size: 14px;
        font-weight: normal;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: normal;
        color: $thin_gray;
        &.invalid-feedback {
          color: red;
          margin-top: 10px;
          position: absolute;
          bottom: -20px;
          font-size: 13px;
          left: 15px;
        }
      }
      .auth-form-password {
        width: 350px;
        float: left;
        position: relative;
        @media screen and (max-width: 768px){
          width: 300px;
        }
      }
      .auth-form-code {
        position: relative;
        width: 330px;
        float: left;
        @media screen and (max-width: 768px){
          width: 300px;
          float: right;
        }
      }
    }
    .auth-form-footer {
      width: 100%;
      position: absolute;
      bottom: 0;
      right: 60px;
      .auth-form-left {
        width: 180px;
        float: left;
        margin-left: 120px;
      }
      .auth-form-right {
        width: 400px;
        float: right;
        text-align: right;
        .btn-enable {
          outline: none;
          width: 255px;
          border: solid 1px $orange;
          font-size: 12px;
          font-weight: bold;
          font-style: normal;
          font-stretch: normal;
          line-height: 2.5;
          letter-spacing: 0.5px;
          text-align: center;
          color: $white;
          background-color: $orange;
          &:hover {
            background: $dark_orange;
            color: white;
          }
        }
      }
    }
  }
  .btn-step {
    outline: none;
  }
</style>
